'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _lexem = require('./lexem');

var _lexem2 = _interopRequireDefault(_lexem);

var _babelute = require('./babelute');

var _babelute2 = _interopRequireDefault(_babelute);

var _fromJson = require('./from-json');

var _fromJson2 = _interopRequireDefault(_fromJson);

var _lexicon = require('./lexicon/lexicon');

var _firstLevel = require('./lexicon/first-level');

var _firstLevel2 = _interopRequireDefault(_firstLevel);

var _pragmaticsCore = require('./pragmatics/pragmatics-core');

var _facadePragmatics = require('./pragmatics/facade-pragmatics');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
	createLexicon: _lexicon.createLexicon,
	createPragmatics: _pragmaticsCore.createPragmatics,
	createFacadePragmatics: _facadePragmatics.createFacadePragmatics,
	init: _lexicon.init,
	initializer: _lexicon.initializer,
	getLexicon: _lexicon.getLexicon,
	registerLexicon: _lexicon.registerLexicon,
	developOneLevel: _lexicon.developOneLevel,
	developToAtoms: _lexicon.developToAtoms,
	fromJSON: _fromJson2.default,
	Babelute: _babelute2.default,
	Lexem: _lexem2.default,
	FirstLevel: _firstLevel2.default,
	Pragmatics: _pragmaticsCore.Pragmatics,
	FacadePragmatics: _facadePragmatics.FacadePragmatics,
	Lexicon: _lexicon.Lexicon,
	lexicons: _lexicon.lexicons
}; /*
    * @author Gilles Coomans
    * @licence MIT
    * @copyright 2016 Gilles Coomans
    */