'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// removed in production

/**
 * Lexem class : a lexem is just an object containing 3 properties { lexicon:String, name:String, args:Arguments|Array }
 * You should never construct them directly (but if you do babelute's plugins). And it should never be extended.
 * @protected
 */
var Lexem =

/**
 * construct a new lexem instance
 * @param  {String} lexicon the lexicon's name of the lexem
 * @param  {String} name    the lexem's name
 * @param  {Array|arguments} args  the lexem's arguments (an array or the "callee arguments" object) 
 */
function Lexem(lexicon, name, args) {
	_classCallCheck(this, Lexem);

	/**
  * the lexicon name from where the lexem comes
  * @type {String}
  */
	this.lexicon = lexicon;

	/**
  * the lexem's name
  * @type {String}
  */
	this.name = name;

	/**
  * The lexem's arguments array (or arguments object)
  * @type {Array|arguments}
  */
	this.args = args;
}; /*
   * @Author: Gilles Coomans
   */

exports.default = Lexem;